#include "tandemWingDesignConfig.h"



tandem::cantilever::WingDesignConfig::WingDesignConfig()
    : wing_design_mode(EndnodeReadOnly<std::string>("program_settings/modes/design_mode")),
      wing_mass_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/mass_method/method")),
      //back_wing_mass_mode(
          //EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/mass/method")),         
      wing_configuration_mode(EndnodeReadOnly<std::string>("program_settings/tandem/wing_configuration")),
      total_wing_area_calculation_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/total_wing_area/method")),
      user_total_wing_area(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/total_wing_area/parameters/mode_0/total_wing_area")),
      
      //kendi yazdiklarim TODO kayra
      user_wing_area_ratio(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/wing_area_ratio/parameters/mode_0/wing_area_ratio")),
      user_relative_LE_stagger(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/relative_LE_stagger/parameters/mode_0/relative_LE_stagger")),

      sweep_calculation_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/sweep_method/method")),
      user_sweep_angle_at_quarter_chord(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/sweep/parameters/mode_0/sweep_angle")),
      korn_technology_factor(EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                                     "sweep/parameters/mode_1/korn_technology_factor")),
      delta_drag_divergence_to_mach_design(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/front_wing/sweep/parameters/"
                                  "mode_1/delta_drag_divergence_to_mach_design")),
      //back_sweep_calculation_mode(
          //EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/sweep/method")), //TODO kayra:delete
      user_back_sweep_angle_at_quarter_chord(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/sweep/parameters/mode_0/sweep_angle")),
      back_korn_technology_factor(EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                                     "sweep/parameters/mode_1/korn_technology_factor")),
      back_delta_drag_divergence_to_mach_design(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/back_wing/sweep/parameters/"
                                  "mode_1/delta_drag_divergence_to_mach_design")),

      taper_ratio_calculation_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/taper_ratio_method/method")),
      user_taper_ratio(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/taper_ratio/parameters/mode_0/taper_ratio")),
      //back_taper_ratio_calculation_mode(EndnodeReadOnly<std::string>(
          //"program_settings/tandem/cantilever/calculation_methods/back_wing/taper_ratio/method")), //TODO kayra:delete
      user_back_taper_ratio(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/taper_ratio/parameters/mode_0/taper_ratio")),          
      
      aspect_ratio_calculation_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/aspect_ratio_method/method")),
      user_aspect_ratio(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/aspect_ratio/parameters/mode_0/aspect_ratio")),
      //back_aspect_ratio_calculation_mode(EndnodeReadOnly<std::string>(
          //"program_settings/tandem/cantilever/calculation_methods/back_wing/aspect_ratio/method")),  //TODO kayra:delete
      user_back_aspect_ratio(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/aspect_ratio/parameters/mode_0/aspect_ratio")),

      dihedral_calculation_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/dihedral_method/method")),
      user_dihedral(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/dihedral/parameters/mode_0/dihedral_angle")),
      dihedral_limitation_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/front_wing/dihedral/"
                                       "parameters/mode_1/dihedral_limitation")),
      //back_dihedral_calculation_mode(EndnodeReadOnly<std::string>(
          //"program_settings/tandem/cantilever/calculation_methods/back_wing/dihedral/method")),  //TODO kayra:delete
      user_back_dihedral(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/dihedral/parameters/mode_0/dihedral_angle")),
      back_dihedral_limitation_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/dihedral/"
                                       "parameters/mode_1/dihedral_limitation")),
                                      
      relative_kink_position_calculation_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/relative_kink_position/method")),
      user_relative_kink(EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                                 "relative_kink_position/parameters/mode_0/relative_kink_position")),
      back_relative_kink_position_calculation_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/relative_kink_position/method")),
      user_back_relative_kink(EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                                 "relative_kink_position/parameters/mode_0/relative_kink_position")),

      user_max_inner_trailing_edge_sweep(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                  "relative_kink_position/parameters/mode_0/maximum_inner_trailing_edge_sweep")),
      user_back_max_inner_trailing_edge_sweep(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                  "relative_kink_position/parameters/mode_0/maximum_inner_trailing_edge_sweep")),

      track_based_initial_relative_kink(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                  "relative_kink_position/parameters/mode_1/initial_relative_kink_position")),
      track_based_max_inner_trailing_edge_sweep(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                  "relative_kink_position/parameters/mode_1/maximum_inner_trailing_edge_sweep")),
      track_based_back_initial_relative_kink(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                  "relative_kink_position/parameters/mode_1/initial_relative_kink_position")),
      track_based_back_max_inner_trailing_edge_sweep(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                  "relative_kink_position/parameters/mode_1/maximum_inner_trailing_edge_sweep")),

      wing_profile_and_thickness_calculation_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                       "wing_profile_and_thickness_distribution/method")),
      torenbeek_jenkinson_wing_profile(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                       "wing_profile_and_thickness_distribution/parameters/mode_1/wing_profile")),
      max_thickness_to_chord_ratio(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/wing_profile_and_thickness_distribution/"
          "parameters/mode_1/max_thickness_to_chord_ratio")),
      airfoil_critical_factor(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/front_wing/"
                                  "wing_profile_and_thickness_distribution/parameters/mode_1/airfoil_critical_factor")),
      back_wing_profile_and_thickness_calculation_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                       "wing_profile_and_thickness_distribution/method")),
      back_torenbeek_jenkinson_wing_profile(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                       "wing_profile_and_thickness_distribution/parameters/mode_1/wing_profile")),
      back_max_thickness_to_chord_ratio(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/wing_profile_and_thickness_distribution/"
          "parameters/mode_1/max_thickness_to_chord_ratio")),
      back_airfoil_critical_factor(
          EndnodeReadOnly<double>("program_settings/tandem/cantilever/calculation_methods/back_wing/"
                                  "wing_profile_and_thickness_distribution/parameters/mode_1/airfoil_critical_factor")),                                  

      control_device_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/control_devices/method")),
      high_lift_device_type_leading_edge(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/front_wing/control_devices/"
                                       "parameters/mode_1/high_lift_device_type_leading_edge")),
      high_lift_device_type_trailing_edge(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/front_wing/control_devices/"
                                       "parameters/mode_1/high_lift_device_type_trailing_edge")),
      back_control_device_mode(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/control_devices/method")),
      back_high_lift_device_type_leading_edge(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/control_devices/"
                                       "parameters/mode_1/high_lift_device_type_leading_edge")),
      back_high_lift_device_type_trailing_edge(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/control_devices/"
                                       "parameters/mode_1/high_lift_device_type_trailing_edge")),        

      spars_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/front_wing/spars/method")),
      back_spars_mode(
          EndnodeReadOnly<std::string>("program_settings/tandem/cantilever/calculation_methods/back_wing/spars/method")),          
      
      flops_fstrt(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/mass/parameters/mode_0/fstrt")),
      flops_faert(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/mass/parameters/mode_0/faert")),
      flops_fcomp(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/mass/parameters/mode_0/fcomp")),
      flops_technology_factor(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/mass/parameters/mode_0/technology_factor")),
      back_flops_fstrt(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/mass/parameters/mode_0/fstrt")),
      back_flops_faert(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/mass/parameters/mode_0/faert")),
      back_flops_fcomp(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/mass/parameters/mode_0/fcomp")),
      back_flops_technology_factor(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/mass/parameters/mode_0/technology_factor")),

      chiozzotto_technology_factor(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/mass/parameters/mode_1/technology_factor")),
      chiozzotto_material(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/mass/parameters/mode_1/material")),
      back_chiozzotto_technology_factor(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/mass/parameters/mode_1/technology_factor")),
      back_chiozzotto_material(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/mass/parameters/mode_1/material")),          
      
      common_airfoil_data_path(EndnodeReadOnly<std::string>("module_configuration_file/program_settings/additional_directory_paths/common_airfoil_data_path")) {}


void tandem::cantilever::WingDesignConfig::read(const node& xml) {
  wing_design_mode.read(xml);
  wing_mass_mode.read(xml);
  //back_wing_mass_mode.read(xml);

  wing_configuration_mode.read(xml);
  total_wing_area_calculation_mode.read(xml);

  user_total_wing_area.read(xml);

  //TODO kayra: beraber degerleri ama WSP silinmesi gerekebilir
  user_wing_area_ratio.read(xml);
  user_relative_LE_stagger.read(xml);
  

  sweep_calculation_mode.read(xml);
  user_sweep_angle_at_quarter_chord.read(xml);
  korn_technology_factor.read(xml);
  delta_drag_divergence_to_mach_design.read(xml);
  
  //back_sweep_calculation_mode.read(xml); //TODO kayra:delete
  user_back_sweep_angle_at_quarter_chord.read(xml);
  back_korn_technology_factor.read(xml);
  back_delta_drag_divergence_to_mach_design.read(xml);

  taper_ratio_calculation_mode.read(xml);
  user_taper_ratio.read(xml);
  //back_taper_ratio_calculation_mode.read(xml); //TODO kayra:delete
  user_back_taper_ratio.read(xml);

  aspect_ratio_calculation_mode.read(xml);
  user_aspect_ratio.read(xml);
  //back_aspect_ratio_calculation_mode.read(xml); //TODO kayra:delete
  user_back_aspect_ratio.read(xml);

  dihedral_calculation_mode.read(xml);
  user_dihedral.read(xml);
  dihedral_limitation_mode.read(xml);
  //back_dihedral_calculation_mode.read(xml);  //TODO kayra:delete
  user_back_dihedral.read(xml);
  back_dihedral_limitation_mode.read(xml);

  relative_kink_position_calculation_mode.read(xml);
  user_relative_kink.read(xml);
  back_relative_kink_position_calculation_mode.read(xml);
  user_back_relative_kink.read(xml);

  user_max_inner_trailing_edge_sweep.read(xml);
  user_back_max_inner_trailing_edge_sweep.read(xml);

  track_based_initial_relative_kink.read(xml);
  track_based_max_inner_trailing_edge_sweep.read(xml);
  track_based_back_initial_relative_kink.read(xml);
  track_based_back_max_inner_trailing_edge_sweep.read(xml);

  wing_profile_and_thickness_calculation_mode.read(xml);
  torenbeek_jenkinson_wing_profile.read(xml);
  max_thickness_to_chord_ratio.read(xml);
  airfoil_critical_factor.read(xml);
  control_device_mode.read(xml);

  back_wing_profile_and_thickness_calculation_mode.read(xml);
  back_torenbeek_jenkinson_wing_profile.read(xml);
  back_max_thickness_to_chord_ratio.read(xml);
  back_airfoil_critical_factor.read(xml);


  control_device_mode.read(xml);
  high_lift_device_type_leading_edge.read(xml);
  high_lift_device_type_trailing_edge.read(xml);

  back_control_device_mode.read(xml);
  back_high_lift_device_type_leading_edge.read(xml);
  back_high_lift_device_type_trailing_edge.read(xml);


  spars_mode.read(xml);
  back_spars_mode.read(xml);
  
  flops_fstrt.read(xml);
  flops_faert.read(xml);
  flops_fcomp.read(xml);

  flops_technology_factor.read(xml);
  back_flops_fstrt.read(xml);
  back_flops_faert.read(xml);
  back_flops_fcomp.read(xml);
  back_flops_technology_factor.read(xml);
  
  chiozzotto_technology_factor.read(xml);
  chiozzotto_material.read(xml);
  back_chiozzotto_technology_factor.read(xml);
  back_chiozzotto_material.read(xml);
  
  common_airfoil_data_path.read(xml);

  // Read user wing profiles thickness and half span position
  if (user_wing_profiles.empty()) {
    node* result;
    int to_count = 0;
    do {
      result = xml.find(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/wing_profile_and_thickness_distribution/"
          "parameters/mode_0/wing_profile_and_thickness@" +
          std::to_string(to_count));
      to_count++;
    } while (result != nullptr);
    to_count--;
    for (int i = 0; i < to_count; ++i) {
      std::string id = std::to_string(i);
      user_wing_profiles.push_back(EndnodeReadOnly<std::string>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/wing_profile_and_thickness_distribution/"
          "parameters/mode_0/wing_profile_and_thickness@" +
          id + "/wing_profile"));
      user_thickness_to_chord.push_back(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/wing_profile_and_thickness_distribution/"
          "parameters/mode_0/wing_profile_and_thickness@" +
          id + "/thickness_to_chord/ratio"));
      user_eta.push_back(EndnodeReadOnly<double>(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/wing_profile_and_thickness_distribution/"
          "parameters/mode_0/wing_profile_and_thickness@" +
          id + "/thickness_to_chord/at_half_span"));
      user_wing_profiles[i].read(xml);
      user_thickness_to_chord[i].read(xml);
      user_eta[i].read(xml);
      user_wing_profiles_and_thickness_vector.push_back(
          {user_eta[i].value(), user_thickness_to_chord[i].value(), user_wing_profiles[i].value()});
    }
  }

    if (user_back_wing_profiles.empty()) {
        node* back_result;
        int to_count = 0;
        do {
        back_result = xml.find(
            "program_settings/tandem/cantilever/calculation_methods/back_wing/wing_profile_and_thickness_distribution/"
            "parameters/mode_0/wing_profile_and_thickness@" +
            std::to_string(to_count));
        to_count++;
        } while (back_result != nullptr);
        to_count--;
    for (int i = 0; i < to_count; ++i) {
        std::string id = std::to_string(i);
        user_back_wing_profiles.push_back(EndnodeReadOnly<std::string>(
            "program_settings/tandem/cantilever/calculation_methods/back_wing/wing_profile_and_thickness_distribution/"
            "parameters/mode_0/wing_profile_and_thickness@" +
            id + "/wing_profile"));
        user_back_thickness_to_chord.push_back(EndnodeReadOnly<double>(
            "program_settings/tandem/cantilever/calculation_methods/back_wing/wing_profile_and_thickness_distribution/"
            "parameters/mode_0/wing_profile_and_thickness@" +
            id + "/thickness_to_chord/ratio"));
        user_back_eta.push_back(EndnodeReadOnly<double>(
            "program_settings/tandem/cantilever/calculation_methods/back_wing/wing_profile_and_thickness_distribution/"
            "parameters/mode_0/wing_profile_and_thickness@" +
            id + "/thickness_to_chord/at_half_span"));
        user_back_wing_profiles[i].read(xml);
        user_back_thickness_to_chord[i].read(xml);
        user_back_eta[i].read(xml);
        user_back_wing_profiles_and_thickness_vector.push_back(
            {user_back_eta[i].value(), user_back_thickness_to_chord[i].value(), user_back_wing_profiles[i].value()});
    }
  }

  // read user defined control surfaces
  if (user_defined_control_devices.empty()) {
    node* result;
    int to_count = 0;
    do {
      result = xml.find(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/control_devices/"
          "parameters/mode_0/control_device@" +
          std::to_string(to_count));
      to_count++;
    } while (result != nullptr);
    to_count--;
    for (int i = 0; i < to_count; ++i) {
      user_defined_control_devices.push_back(
          ControlDevice("program_settings/tandem/cantilever/calculation_methods/front_wing/control_devices/"
                        "parameters/mode_0/control_device@" +
                        std::to_string(i) + "/"));
      user_defined_control_devices.back().read(xml);
    }
  }

    if (user_defined_back_control_devices.empty()) {
    node* back_result;
    int to_count = 0;
    do {
      back_result = xml.find(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/control_devices/"
          "parameters/mode_0/control_device@" +
          std::to_string(to_count));
      to_count++;
    } while (back_result != nullptr);
    to_count--;
    for (int i = 0; i < to_count; ++i) {
      user_defined_back_control_devices.push_back(
          ControlDevice("program_settings/tandem/cantilever/calculation_methods/back_wing/control_devices/"
                        "parameters/mode_0/control_device@" +
                        std::to_string(i) + "/"));
      user_defined_back_control_devices.back().read(xml);
    }
  }
  
  // read user defined spars
  if (user_defined_spars.empty()) {
    node* result;
    int to_count = 0;
    do {
      result = xml.find(
          "program_settings/tandem/cantilever/calculation_methods/front_wing/spars/"
          "parameters/mode_0/spar@" +
          std::to_string(to_count));
      to_count++;
    } while (result != nullptr);
    to_count--;
    for (int i = 0; i < to_count; ++i) {
      user_defined_spars.push_back(
          Spar("program_settings/tandem/cantilever/calculation_methods/front_wing/spars/"
               "parameters/mode_0/spar@" +
               std::to_string(i) + "/"));
      user_defined_spars.back().read(xml);
    }
  }

    if (user_defined_back_spars.empty()) {
    node* back_result;
    int to_count = 0;
    do {
      back_result = xml.find(
          "program_settings/tandem/cantilever/calculation_methods/back_wing/spars/"
          "parameters/mode_0/spar@" +
          std::to_string(to_count));
      to_count++;
    } while (back_result != nullptr);
    to_count--;
    for (int i = 0; i < to_count; ++i) {
      user_defined_back_spars.push_back(
          Spar("program_settings/tandem/cantilever/calculation_methods/back_wing/spars/"
               "parameters/mode_0/spar@" +
               std::to_string(i) + "/"));
      user_defined_back_spars.back().read(xml);
    }
  }
}
